# -*- coding: utf-8 -*-
##############################################################################
#
#    Copyright (C) 2014 XCG Consulting (www.xcg-consulting.fr)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from openerp.osv import osv, fields
from openerp.tools.misc import DEFAULT_SERVER_DATE_FORMAT
import datetime


class rrule_preview(osv.TransientModel):
    _name = 'rrules.rrule_preview'

    _columns = {
        'next0': fields.date(
            "1",
            readonly=True,
        ),
        'next1': fields.date(
            "2",
            readonly=True,
        ),
        'next2': fields.date(
            "3",
            readonly=True,
        ),
        'next3': fields.date(
            "4",
            readonly=True,
        ),
        'next4': fields.date(
            "5",
            readonly=True,
        ),
        'next5': fields.date(
            "6",
            readonly=True,
        ),
        'next6': fields.date(
            "7",
            readonly=True,
        ),
    }

    def default_get(self, cr, uid, fields, context=None):
        """framework callback that initializes the data upon display by
        the client side
        """
        res = super(rrule_preview, self).default_get(cr, uid, fields, context)
        if 'active_id' in context:
            rrule_osv = self.pool.get('rrules.rrule')
            rrule_dict = rrule_osv.get_rrule(
                cr, uid, [context['active_id']], None, context=context)
            rrule = rrule_dict[context['active_id']]
            for i in range(0, 7):
                try:
                    res['next' + str(i)] = datetime.datetime.strftime(
                        rrule[i], DEFAULT_SERVER_DATE_FORMAT)
                except IndexError:
                    break
        return res
